diff --git a/gcc/fortran/cpp.c b/gcc/fortran/cpp.c
index 68ce91f..e5b54c7 100644
--- a/gcc/fortran/cpp.c
+++ b/gcc/fortran/cpp.c
@@ -468,7 +468,7 @@ gfc_cpp_post_options (void)
   cpp_option->traditional = 1;
   cpp_option->cplusplus_comments = 0;
 
-  cpp_option->cpp_pedantic = pedantic;
+  cpp_option->cpp_pedantic = GCC_OPTION (pedantic);
 
   cpp_option->dollars_in_ident = gfc_option.flag_dollar_ok;
   cpp_option->discard_comments = gfc_cpp_option.discard_comments;
@@ -489,7 +489,7 @@ gfc_cpp_post_options (void)
   }
 
   if (gfc_cpp_option.working_directory == -1)
-    gfc_cpp_option.working_directory = (debug_info_level != DINFO_LEVEL_NONE);
+    gfc_cpp_option.working_directory = (GCC_OPTION (debug_info_level) != DINFO_LEVEL_NONE);
 
   cpp_post_options (cpp_in);
 
@@ -544,7 +544,7 @@ gfc_cpp_init_0 (void)
 	     is necessary to redirect assembler output (actually nothing
 	     as -E implies -fsyntax-only) to another file, otherwise the
 	     output from preprocessing is lost.  */
-	  asm_file_name = gfc_cpp_option.temporary_filename;
+	  GCC_OPTION (asm_file_name) = gfc_cpp_option.temporary_filename;
 
 	  print.outf = fopen (gfc_cpp_option.output_filename, "w");
 	  if (print.outf == NULL)
diff --git a/gcc/fortran/decl.c b/gcc/fortran/decl.c
index 4048ac9..c5cb40d 100644
--- a/gcc/fortran/decl.c
+++ b/gcc/fortran/decl.c
@@ -5940,7 +5940,7 @@ set_enum_kind(void)
   if (max_enum == NULL || enum_history == NULL)
     return;
 
-  if (!flag_short_enums)
+  if (!GCC_OPTION (flag_short_enums))
     return;
 
   i = 0;
diff --git a/gcc/fortran/error.c b/gcc/fortran/error.c
index e843fa5..ee293da 100644
--- a/gcc/fortran/error.c
+++ b/gcc/fortran/error.c
@@ -808,7 +808,7 @@ gfc_warning (const char *gmsgid, ...)
 {
   va_list argp;
 
-  if (inhibit_warnings)
+  if (GCC_OPTION (inhibit_warnings))
     return;
 
   warning_buffer.flag = 1;
@@ -824,7 +824,7 @@ gfc_warning (const char *gmsgid, ...)
   if (buffer_flag == 0)
   {
     warnings++;
-    if (warnings_are_errors)
+    if (GCC_OPTION (warnings_are_errors))
       gfc_increment_error_count();
   }
 }
@@ -838,7 +838,7 @@ gfc_notification_std (int std)
 {
   bool warning;
 
-  warning = ((gfc_option.warn_std & std) != 0) && !inhibit_warnings;
+  warning = ((gfc_option.warn_std & std) != 0) && !GCC_OPTION (inhibit_warnings);
   if ((gfc_option.allow_std & std) != 0 && !warning)
     return SILENT;
 
@@ -859,7 +859,7 @@ gfc_notify_std (int std, const char *gmsgid, ...)
   const char *msg1, *msg2;
   char *buffer;
 
-  warning = ((gfc_option.warn_std & std) != 0) && !inhibit_warnings;
+  warning = ((gfc_option.warn_std & std) != 0) && !GCC_OPTION (inhibit_warnings);
   if ((gfc_option.allow_std & std) != 0 && !warning)
     return true;
 
@@ -918,14 +918,14 @@ gfc_notify_std (int std, const char *gmsgid, ...)
 
   if (buffer_flag == 0)
     {
-      if (warning && !warnings_are_errors)
+      if (warning && !GCC_OPTION (warnings_are_errors))
 	warnings++;
       else
 	gfc_increment_error_count();
       cur_error_buffer->flag = 0;
     }
 
-  return (warning && !warnings_are_errors) ? true : false;
+  return (warning && !GCC_OPTION (warnings_are_errors)) ? true : false;
 }
 
 
@@ -937,7 +937,7 @@ gfc_warning_now (const char *gmsgid, ...)
   va_list argp;
   int i;
 
-  if (inhibit_warnings)
+  if (GCC_OPTION (inhibit_warnings))
     return;
 
   i = buffer_flag;
@@ -950,7 +950,7 @@ gfc_warning_now (const char *gmsgid, ...)
 
   error_char ('\0');
 
-  if (warnings_are_errors)
+  if (GCC_OPTION (warnings_are_errors))
     gfc_increment_error_count();
 
   buffer_flag = i;
@@ -1012,7 +1012,7 @@ gfc_error (const char *gmsgid, ...)
 
 warning:
 
-  if (inhibit_warnings)
+  if (GCC_OPTION (inhibit_warnings))
     return;
 
   warning_buffer.flag = 1;
@@ -1028,7 +1028,7 @@ warning:
   if (buffer_flag == 0)
   {
     warnings++;
-    if (warnings_are_errors)
+    if (GCC_OPTION (warnings_are_errors))
       gfc_increment_error_count();
   }
 }
@@ -1059,7 +1059,7 @@ gfc_error_now (const char *gmsgid, ...)
 
   buffer_flag = i;
 
-  if (flag_fatal_errors)
+  if (GCC_OPTION (flag_fatal_errors))
     exit (FATAL_EXIT_CODE);
 }
 
@@ -1139,7 +1139,7 @@ gfc_error_check (void)
 
       gfc_increment_error_count();
 
-      if (flag_fatal_errors)
+      if (GCC_OPTION (flag_fatal_errors))
 	exit (FATAL_EXIT_CODE);
     }
 
diff --git a/gcc/fortran/f95-lang.c b/gcc/fortran/f95-lang.c
index e25e92a..67057a6 100644
--- a/gcc/fortran/f95-lang.c
+++ b/gcc/fortran/f95-lang.c
@@ -223,7 +223,7 @@ gfc_init (void)
   if (!gfc_new_file ())
     fatal_error ("can't open input file: %s", gfc_source_file);
 
-  if (flag_preprocess_only)
+  if (GCC_OPTION (flag_preprocess_only))
     return false;
 
   return true;
@@ -1038,7 +1038,7 @@ gfc_init_builtin_functions (void)
 #include "../sync-builtins.def"
 #undef DEF_SYNC_BUILTIN
 
-  if (gfc_option.gfc_flag_openmp || flag_tree_parallelize_loops)
+  if (gfc_option.gfc_flag_openmp || GCC_OPTION (flag_tree_parallelize_loops))
     {
 #undef DEF_GOMP_BUILTIN
 #define DEF_GOMP_BUILTIN(code, name, type, attr) \
@@ -1081,7 +1081,7 @@ gfc_init_ts (void)
 void
 gfc_maybe_initialize_eh (void)
 {
-  if (!flag_exceptions || gfc_eh_initialized_p)
+  if (!GCC_OPTION (flag_exceptions) || gfc_eh_initialized_p)
     return;
 
   gfc_eh_initialized_p = true;
diff --git a/gcc/fortran/frontend-passes.c b/gcc/fortran/frontend-passes.c
index e663868..bddec04 100644
--- a/gcc/fortran/frontend-passes.c
+++ b/gcc/fortran/frontend-passes.c
@@ -1381,7 +1381,7 @@ optimize_comparison (gfc_expr *e, gfc_intrinsic_op op)
 
   /* Don't compare REAL or COMPLEX expressions when honoring NaNs.  */
 
-  if (flag_finite_math_only
+  if (GCC_OPTION (flag_finite_math_only)
       || (op1->ts.type != BT_REAL && op2->ts.type != BT_REAL
 	  && op1->ts.type != BT_COMPLEX && op2->ts.type != BT_COMPLEX))
     {
diff --git a/gcc/fortran/io.c b/gcc/fortran/io.c
index 84d0db8..739b677 100644
--- a/gcc/fortran/io.c
+++ b/gcc/fortran/io.c
@@ -164,7 +164,7 @@ next_char (gfc_instring in_string)
       if (gfc_match_special_char (&c) == MATCH_NO)
 	gfc_current_locus = old_locus;
 
-      if (!(gfc_option.allow_std & GFC_STD_GNU) && !inhibit_warnings)
+      if (!(gfc_option.allow_std & GFC_STD_GNU) && !GCC_OPTION (inhibit_warnings))
 	gfc_warning ("Extension: backslash character at %C");
     }
 
@@ -964,7 +964,7 @@ data_desc:
       break;
 
     case FMT_H:
-      if (!(gfc_option.allow_std & GFC_STD_GNU) && !inhibit_warnings)
+      if (!(gfc_option.allow_std & GFC_STD_GNU) && !GCC_OPTION (inhibit_warnings))
 	{
 	  if (mode != MODE_FORMAT)
 	    format_locus.nextc += format_string_pos;
diff --git a/gcc/fortran/options.c b/gcc/fortran/options.c
index a2b91ca..dc14968 100644
--- a/gcc/fortran/options.c
+++ b/gcc/fortran/options.c
@@ -263,21 +263,21 @@ gfc_post_options (const char **pfilename)
 
   /* Excess precision other than "fast" requires front-end
      support.  */
-  if (flag_excess_precision_cmdline == EXCESS_PRECISION_STANDARD
+  if (GCC_OPTION (flag_excess_precision_cmdline) == EXCESS_PRECISION_STANDARD
       && TARGET_FLT_EVAL_METHOD_NON_DEFAULT)
     sorry ("-fexcess-precision=standard for Fortran");
-  flag_excess_precision_cmdline = EXCESS_PRECISION_FAST;
+  GCC_OPTION (flag_excess_precision_cmdline) = EXCESS_PRECISION_FAST;
 
   /* Fortran allows associative math - but we cannot reassociate if
      we want traps or signed zeros. Cf. also flag_protect_parens.  */
-  if (flag_associative_math == -1)
-    flag_associative_math = (!flag_trapping_math && !flag_signed_zeros);
+  if (GCC_OPTION (flag_associative_math) == -1)
+    GCC_OPTION (flag_associative_math) = (!GCC_OPTION (flag_trapping_math) && !GCC_OPTION (flag_signed_zeros));
 
   if (gfc_option.flag_protect_parens == -1)
-    gfc_option.flag_protect_parens = !optimize_fast;
+    gfc_option.flag_protect_parens = !GCC_OPTION (optimize_fast);
 
   if (gfc_option.flag_stack_arrays == -1)
-    gfc_option.flag_stack_arrays = optimize_fast;
+    gfc_option.flag_stack_arrays = GCC_OPTION (optimize_fast);
 
   /* By default, disable (re)allocation during assignment for -std=f95,
      and enable it for F2003/F2008/GNU/Legacy. */
@@ -290,15 +290,15 @@ gfc_post_options (const char **pfilename)
     }
 
   /* -fbounds-check is equivalent to -fcheck=bounds */
-  if (flag_bounds_check)
+  if (GCC_OPTION (flag_bounds_check))
     gfc_option.rtcheck |= GFC_RTCHECK_BOUNDS;
 
-  if (flag_compare_debug)
+  if (GCC_OPTION (flag_compare_debug))
     gfc_option.dump_fortran_original = 0;
 
   /* Make -fmax-errors visible to gfortran's diagnostic machinery.  */
   if (global_options_set.x_flag_max_errors)
-    gfc_option.max_errors = flag_max_errors;
+    gfc_option.max_errors = GCC_OPTION (flag_max_errors);
 
   /* Verify the input file name.  */
   if (!filename || strcmp (filename, "-") == 0)
@@ -369,10 +369,10 @@ gfc_post_options (const char **pfilename)
     }
 
   /* If -pedantic, warn about the use of GNU extensions.  */
-  if (pedantic && (gfc_option.allow_std & GFC_STD_GNU) != 0)
+  if (GCC_OPTION (pedantic) && (gfc_option.allow_std & GFC_STD_GNU) != 0)
     gfc_option.warn_std |= GFC_STD_GNU;
   /* -std=legacy -pedantic is effectively -std=gnu.  */
-  if (pedantic && (gfc_option.allow_std & GFC_STD_LEGACY) != 0)
+  if (GCC_OPTION (pedantic) && (gfc_option.allow_std & GFC_STD_LEGACY) != 0)
     gfc_option.warn_std |= GFC_STD_F95_OBS | GFC_STD_F95_DEL | GFC_STD_LEGACY;
 
   /* If the user didn't explicitly specify -f(no)-second-underscore we
@@ -420,7 +420,7 @@ gfc_post_options (const char **pfilename)
   if (!gfc_option.flag_automatic)
     gfc_option.flag_max_stack_var_size = 0;
   
-  if (pedantic)
+  if (GCC_OPTION (pedantic))
     { 
       gfc_option.warn_ampersand = 1;
       gfc_option.warn_tabs = 0;
@@ -430,7 +430,7 @@ gfc_post_options (const char **pfilename)
      specified it directly.  */
 
   if (gfc_option.flag_frontend_optimize == -1)
-    gfc_option.flag_frontend_optimize = optimize;
+    gfc_option.flag_frontend_optimize = GCC_OPTION (optimize);
 
   if (gfc_option.warn_realloc_lhs_all)
     gfc_option.warn_realloc_lhs = 1;
@@ -462,9 +462,9 @@ set_Wall (int setting)
   gfc_option.warn_target_lifetime = setting;
   gfc_option.warn_zerotrip = setting;
 
-  warn_return_type = setting;
-  warn_uninitialized = setting;
-  warn_maybe_uninitialized = setting;
+  GCC_OPTION (warn_return_type) = setting;
+  GCC_OPTION (warn_uninitialized) = setting;
+  GCC_OPTION (warn_maybe_uninitialized) = setting;
 }
 
 /* Set the options for -Wextra.  */
@@ -707,7 +707,7 @@ gfc_handle_option (size_t scode, const char *arg, int value,
       break;
 
     case OPT_Wreturn_type:
-      warn_return_type = value;
+      GCC_OPTION (warn_return_type) = value;
       break;
 
     case OPT_Wsurprising:
diff --git a/gcc/fortran/primary.c b/gcc/fortran/primary.c
index e2eb467..93fa45f 100644
--- a/gcc/fortran/primary.c
+++ b/gcc/fortran/primary.c
@@ -863,7 +863,7 @@ next_string_char (gfc_char_t delimiter, int *ret)
       if (gfc_match_special_char (&c) == MATCH_NO)
 	gfc_current_locus = old_locus;
 
-      if (!(gfc_option.allow_std & GFC_STD_GNU) && !inhibit_warnings)
+      if (!(gfc_option.allow_std & GFC_STD_GNU) && !GCC_OPTION (inhibit_warnings))
 	gfc_warning ("Extension: backslash character at %C");
     }
 
diff --git a/gcc/fortran/resolve.c b/gcc/fortran/resolve.c
index 6e23e57..d163b65 100644
--- a/gcc/fortran/resolve.c
+++ b/gcc/fortran/resolve.c
@@ -2093,7 +2093,7 @@ resolve_elemental_actual (gfc_expr *expr, gfc_code *c)
       else if (isym)
 	formal_optional = true;
 
-      if (pedantic && arg->expr != NULL
+      if (GCC_OPTION (pedantic) && arg->expr != NULL
 	  && arg->expr->expr_type == EXPR_VARIABLE
 	  && arg->expr->symtree->n.sym->attr.optional
 	  && formal_optional
@@ -2429,7 +2429,7 @@ resolve_global_procedure (gfc_symbol *sym, locus *where,
 	  goto done;
 	}
 
-      if (!pedantic && (gfc_option.allow_std & GFC_STD_GNU))
+      if (!GCC_OPTION (pedantic) && (gfc_option.allow_std & GFC_STD_GNU))
 	/* Turn erros into warnings with -std=gnu and -std=legacy.  */
 	gfc_errors_to_warnings (1);
 
@@ -2441,7 +2441,7 @@ resolve_global_procedure (gfc_symbol *sym, locus *where,
 	  goto done;
 	}
 
-      if (!pedantic
+      if (!GCC_OPTION (pedantic)
 	  || ((gfc_option.warn_std & GFC_STD_LEGACY)
 	      && !(gfc_option.warn_std & GFC_STD_GNU)))
 	gfc_errors_to_warnings (1);
@@ -14572,7 +14572,7 @@ resolve_types (gfc_namespace *ns)
     resolve_equivalence (eq);
 
   /* Warn about unused labels.  */
-  if (warn_unused_label)
+  if (GCC_OPTION (warn_unused_label))
     warn_unused_fortran_label (ns->st_labels);
 
   gfc_resolve_uops (ns->uop_root);
diff --git a/gcc/fortran/scanner.c b/gcc/fortran/scanner.c
index 8f51734..ec814ad 100644
--- a/gcc/fortran/scanner.c
+++ b/gcc/fortran/scanner.c
@@ -658,7 +658,7 @@ gfc_define_undef_line (void)
   char *tmp;
 
   /* All lines beginning with '#' are either #define or #undef.  */
-  if (debug_info_level != DINFO_LEVEL_VERBOSE || gfc_peek_ascii_char () != '#')
+  if (GCC_OPTION (debug_info_level) != DINFO_LEVEL_VERBOSE || gfc_peek_ascii_char () != '#')
     return 0;
 
   if (wide_strncmp (gfc_current_locus.nextc, "#define ", 8) == 0)
@@ -1107,7 +1107,7 @@ restart:
 	{
 	  if (++continue_count == gfc_option.max_continue_free)
 	    {
-	      if (gfc_notification_std (GFC_STD_GNU) || pedantic)
+	      if (gfc_notification_std (GFC_STD_GNU) || GCC_OPTION (pedantic))
 		gfc_warning ("Limit of %d continuations exceeded in "
 			     "statement at %C", gfc_option.max_continue_free);
 	    }
@@ -1239,7 +1239,7 @@ restart:
 	{
 	  if (++continue_count == gfc_option.max_continue_fixed)
 	    {
-	      if (gfc_notification_std (GFC_STD_GNU) || pedantic)
+	      if (gfc_notification_std (GFC_STD_GNU) || GCC_OPTION (pedantic))
 		gfc_warning ("Limit of %d continuations exceeded in "
 			     "statement at %C",
 			     gfc_option.max_continue_fixed);
@@ -1477,7 +1477,7 @@ load_line (FILE *input, gfc_char_t **pbuf, int *pbuflen, const int *first_char)
 	  if (gfc_current_form == FORM_FREE 
 	      && !seen_printable && seen_ampersand)
 	    {
-	      if (pedantic)
+	      if (GCC_OPTION (pedantic))
 		gfc_error_now ("'&' not allowed by itself in line %d",
 			       current_line);
 	      else
@@ -2017,7 +2017,7 @@ load_file (const char *realfilename, const char *displayedname, bool initial)
 	  /* When -g3 is specified, it's possible that we emit #define
 	     and #undef lines, which we need to pass to the middle-end
 	     so that it can emit correct debug info.  */
-	  if (debug_info_level == DINFO_LEVEL_VERBOSE
+	  if (GCC_OPTION (debug_info_level) == DINFO_LEVEL_VERBOSE
 	      && (wide_strncmp (line, "#define ", 8) == 0
 		  || wide_strncmp (line, "#undef ", 7) == 0))
 	    ;
diff --git a/gcc/fortran/trans-decl.c b/gcc/fortran/trans-decl.c
index cf7b661..8189895 100644
--- a/gcc/fortran/trans-decl.c
+++ b/gcc/fortran/trans-decl.c
@@ -3614,7 +3614,7 @@ gfc_trans_deferred_vars (gfc_symbol * proc_sym, gfc_wrapped_block * block)
 		  break;
 	    }
 	  /* TODO: move to the appropriate place in resolve.c.  */
-	  if (warn_return_type && el == NULL)
+	  if (GCC_OPTION (warn_return_type) && el == NULL)
 	    gfc_warning ("Return value of function '%s' at %L not set",
 			 proc_sym->name, &proc_sym->declared_at);
 	}
@@ -4257,7 +4257,7 @@ gfc_create_module_variable (gfc_symbol * sym)
 		  && gfc_option.flag_module_private))))
     sym->attr.access = ACCESS_PRIVATE;
 
-  if (warn_unused_variable && !sym->attr.referenced
+  if (GCC_OPTION (warn_unused_variable) && !sym->attr.referenced
       && sym->attr.access == ACCESS_PRIVATE)
     gfc_warning ("Unused PRIVATE module variable '%s' declared at %L",
 		 sym->name, &sym->declared_at);
@@ -4834,7 +4834,7 @@ generate_local_decl (gfc_symbol * sym)
 
       /* Warn for unused variables, but not if they're inside a common
 	 block or a namelist.  */
-      else if (warn_unused_variable
+      else if (GCC_OPTION (warn_unused_variable)
 	       && !(sym->attr.in_common || sym->mark || sym->attr.in_namelist))
 	{
 	  if (sym->attr.use_only)
@@ -4891,7 +4891,7 @@ generate_local_decl (gfc_symbol * sym)
     }
   else if (sym->attr.flavor == FL_PARAMETER)
     {
-      if (warn_unused_parameter
+      if (GCC_OPTION (warn_unused_parameter)
            && !sym->attr.referenced)
 	{
            if (!sym->attr.use_assoc)
@@ -4905,7 +4905,7 @@ generate_local_decl (gfc_symbol * sym)
   else if (sym->attr.flavor == FL_PROCEDURE)
     {
       /* TODO: move to the appropriate place in resolve.c.  */
-      if (warn_return_type
+      if (GCC_OPTION (warn_return_type)
 	  && sym->attr.function
 	  && sym->result
 	  && sym != sym->result
@@ -5281,7 +5281,7 @@ create_main_function (tree fndecl)
                             build_int_cst (integer_type_node,
                                            gfc_option.allow_std));
     CONSTRUCTOR_APPEND_ELT (v, NULL_TREE,
-                            build_int_cst (integer_type_node, pedantic));
+                            build_int_cst (integer_type_node, GCC_OPTION (pedantic)));
     /* TODO: This is the old -fdump-core option, which is unused but
        passed due to ABI compatibility; remove when bumping the
        library ABI.  */
@@ -5644,10 +5644,10 @@ gfc_generate_function_code (gfc_namespace * ns)
       if (result == NULL_TREE)
 	{
 	  /* TODO: move to the appropriate place in resolve.c.  */
-	  if (warn_return_type && sym == sym->result)
+	  if (GCC_OPTION (warn_return_type) && sym == sym->result)
 	    gfc_warning ("Return value of function '%s' at %L not set",
 			 sym->name, &sym->declared_at);
-	  if (warn_return_type)
+	  if (GCC_OPTION (warn_return_type))
 	    TREE_NO_WARNING(sym->backend_decl) = 1;
 	}
       else
diff --git a/gcc/fortran/trans-expr.c b/gcc/fortran/trans-expr.c
index f5350bb..174aadd 100644
--- a/gcc/fortran/trans-expr.c
+++ b/gcc/fortran/trans-expr.c
@@ -2102,8 +2102,8 @@ gfc_conv_cst_int_power (gfc_se * se, tree lhs, tree rhs)
   type = TREE_TYPE (lhs);
   sgn = tree_int_cst_sgn (rhs);
 
-  if (((FLOAT_TYPE_P (type) && !flag_unsafe_math_optimizations)
-       || optimize_size) && (m > 2 || m < -1))
+  if (((FLOAT_TYPE_P (type) && !GCC_OPTION (flag_unsafe_math_optimizations))
+       || GCC_OPTION (optimize_size)) && (m > 2 || m < -1))
     return 0;
 
   /* rhs == 0  */
@@ -2823,7 +2823,7 @@ gfc_build_compare_string (tree len1, tree str1, tree len2, tree str2, int kind,
     }
 
   if ((code == EQ_EXPR || code == NE_EXPR)
-      && optimize
+      && GCC_OPTION (optimize)
       && INTEGER_CST_P (len1) && INTEGER_CST_P (len2))
     {
       /* If one string is a string literal with LEN_TRIM longer
diff --git a/gcc/fortran/trans-intrinsic.c b/gcc/fortran/trans-intrinsic.c
index e21d52f..afc14d7 100644
--- a/gcc/fortran/trans-intrinsic.c
+++ b/gcc/fortran/trans-intrinsic.c
@@ -1823,7 +1823,7 @@ gfc_conv_intrinsic_mod (gfc_se * se, gfc_expr * expr, int modulo)
 
       zero = gfc_build_const (type, integer_zero_node);
       tmp = gfc_evaluate_now (se->expr, &se->pre);
-      if (!flag_signed_zeros)
+      if (!GCC_OPTION (flag_signed_zeros))
 	{
 	  test = fold_build2_loc (input_location, LT_EXPR, boolean_type_node,
 				  args[0], zero);
@@ -7403,7 +7403,7 @@ gfc_inline_intrinsic_function_p (gfc_expr *expr)
     case GFC_ISYM_PRODUCT:
     case GFC_ISYM_SUM:
       /* Disable inline expansion if code size matters.  */
-      if (optimize_size)
+      if (GCC_OPTION (optimize_size))
 	return false;
 
       args = expr->value.function.actual;
diff --git a/gcc/fortran/trans-stmt.c b/gcc/fortran/trans-stmt.c
index 1a9068c..af54adc 100644
--- a/gcc/fortran/trans-stmt.c
+++ b/gcc/fortran/trans-stmt.c
@@ -2184,7 +2184,7 @@ gfc_trans_character_select (gfc_code *code)
 		      break;
 		  if (i != d->low->value.character.length)
 		    {
-		      if (optimize && d->high && i == 1)
+		      if (GCC_OPTION (optimize) && d->high && i == 1)
 			{
 			  gcc_assert (d->high->expr_type == EXPR_CONSTANT
 				      && d->high->ts.type == BT_CHARACTER);
diff --git a/gcc/fortran/trans.c b/gcc/fortran/trans.c
index 5961c26..d990d3e 100644
--- a/gcc/fortran/trans.c
+++ b/gcc/fortran/trans.c
@@ -2035,7 +2035,7 @@ gfc_unlikely (tree cond, enum br_predictor predictor)
 {
   tree tmp;
 
-  if (optimize)
+  if (GCC_OPTION (optimize))
     {
       cond = fold_convert (long_integer_type_node, cond);
       tmp = build_zero_cst (long_integer_type_node);
@@ -2057,7 +2057,7 @@ gfc_likely (tree cond, enum br_predictor predictor)
 {
   tree tmp;
 
-  if (optimize)
+  if (GCC_OPTION (optimize))
     {
       cond = fold_convert (long_integer_type_node, cond);
       tmp = build_one_cst (long_integer_type_node);
diff --git a/gcc/function.c b/gcc/function.c
index a61e475..1463fbf 100644
--- a/gcc/function.c
+++ b/gcc/function.c
@@ -991,14 +991,14 @@ combine_temp_slots (void)
 
   /* We can't combine slots, because the information about which slot
      is in which alias set will be lost.  */
-  if (flag_strict_aliasing)
+  if (GCC_OPTION (flag_strict_aliasing))
     return;
 
   /* If there are a lot of temp slots, don't do anything unless
      high levels of optimization.  */
-  if (! flag_expensive_optimizations)
+  if (! GCC_OPTION (flag_expensive_optimizations))
     for (p = avail_temp_slots, num_slots = 0; p; p = p->next, num_slots++)
-      if (num_slots > 100 || (num_slots > 10 && optimize == 0))
+      if (num_slots > 100 || (num_slots > 10 && GCC_OPTION (optimize) == 0))
 	return;
 
   for (p = avail_temp_slots; p; p = next)
@@ -2041,7 +2041,7 @@ aggregate_value_p (const_tree exp, const_tree fntype)
   if (TREE_ADDRESSABLE (type))
     return 1;
 
-  if (flag_pcc_struct_return && AGGREGATE_TYPE_P (type))
+  if (GCC_OPTION (flag_pcc_struct_return) && AGGREGATE_TYPE_P (type))
     return 1;
 
   if (targetm.calls.return_in_memory (type, fntype))
@@ -2090,7 +2090,7 @@ use_register_for_decl (const_tree decl)
      into registers.  */
   /* ??? This should be checked after DECL_ARTIFICIAL, but tree-ssa
      propagates values across these stores, and it probably shouldn't.  */
-  if (flag_float_store && FLOAT_TYPE_P (TREE_TYPE (decl)))
+  if (GCC_OPTION (flag_float_store) && FLOAT_TYPE_P (TREE_TYPE (decl)))
     return false;
 
   /* If we're not interested in tracking debugging information for
@@ -2098,7 +2098,7 @@ use_register_for_decl (const_tree decl)
   if (DECL_IGNORED_P (decl))
     return true;
 
-  if (optimize)
+  if (GCC_OPTION (optimize))
     return true;
 
   if (!DECL_REGISTER (decl))
@@ -2743,7 +2743,7 @@ assign_parm_adjust_stack_rtl (struct assign_parm_data_one *data)
   /* If stack protection is in effect for this function, don't leave any
      pointers in their passed stack slots.  */
   else if (crtl->stack_protect_guard
-	   && (flag_stack_protect == 2
+	   && (GCC_OPTION (flag_stack_protect) == 2
 	       || data->passed_pointer
 	       || POINTER_TYPE_P (data->nominal_type)))
     stack_parm = NULL;
@@ -3646,7 +3646,7 @@ gimplify_parameters (void)
 	      /* For constant-sized objects, this is trivial; for
 		 variable-sized objects, we have to play games.  */
 	      if (TREE_CODE (DECL_SIZE_UNIT (parm)) == INTEGER_CST
-		  && !(flag_stack_check == GENERIC_STACK_CHECK
+		  && !(GCC_OPTION (flag_stack_check) == GENERIC_STACK_CHECK
 		       && compare_tree_int (DECL_SIZE_UNIT (parm),
 					    STACK_CHECK_MAX_VAR_SIZE) > 0))
 		{
@@ -4339,7 +4339,7 @@ number_blocks (tree fn)
      from 1 within each function, rather than keeping a running
      count.  */
 #if defined (SDB_DEBUGGING_INFO) || defined (XCOFF_DEBUGGING_INFO)
-  if (write_symbols == SDB_DEBUG || write_symbols == XCOFF_DEBUG)
+  if (GCC_OPTION (write_symbols) == SDB_DEBUG || GCC_OPTION (write_symbols) == XCOFF_DEBUG)
     next_block_index = 1;
 #endif
 
@@ -4535,7 +4535,7 @@ allocate_struct_function (tree fndecl, bool abstract_p)
 
       /* ??? This could be set on a per-function basis by the front-end
          but is this worth the hassle?  */
-      cfun->can_throw_non_call_exceptions = flag_non_call_exceptions;
+      cfun->can_throw_non_call_exceptions = GCC_OPTION (flag_non_call_exceptions);
     }
 }
 
@@ -4568,13 +4568,13 @@ prepare_function_start (void)
   init_expr ();
   default_rtl_profile ();
 
-  if (flag_stack_usage_info)
+  if (GCC_OPTION (flag_stack_usage_info))
     {
       cfun->su = ggc_alloc_cleared_stack_usage ();
       cfun->su->static_stack_size = -1;
     }
 
-  cse_not_expected = ! optimize;
+  cse_not_expected = ! GCC_OPTION (optimize);
 
   /* Caller save not needed yet.  */
   caller_save_needed = 0;
@@ -4690,7 +4690,7 @@ expand_function_start (tree subr)
   init_recog_no_volatile ();
 
   crtl->profile
-    = (profile_flag
+    = (GCC_OPTION (profile_flag)
        && ! DECL_NO_INSTRUMENT_FUNCTION_ENTRY_EXIT (subr));
 
   crtl->limit_stack
@@ -4844,7 +4844,7 @@ expand_function_start (tree subr)
     }
 
   /* If we are doing generic stack checking, the probe should go here.  */
-  if (flag_stack_check == GENERIC_STACK_CHECK)
+  if (GCC_OPTION (flag_stack_check) == GENERIC_STACK_CHECK)
     stack_check_probe_note = emit_note (NOTE_INSN_DELETED);
 }
 
@@ -4971,7 +4971,7 @@ expand_function_end (void)
   /* If we are doing generic stack checking and this function makes calls,
      do a stack probe at the start of the function to ensure we have enough
      space for another stack frame.  */
-  if (flag_stack_check == GENERIC_STACK_CHECK)
+  if (GCC_OPTION (flag_stack_check) == GENERIC_STACK_CHECK)
     {
       rtx insn, seq;
 
@@ -5020,7 +5020,7 @@ expand_function_end (void)
     {
       /* Let except.c know where it should emit the call to unregister
 	 the function context for sjlj exceptions.  */
-      if (flag_exceptions)
+      if (GCC_OPTION (flag_exceptions))
 	sjlj_emit_function_exit_after (get_last_insn ());
     }
   else
@@ -5913,7 +5913,7 @@ thread_prologue_and_epilogue_insns (void)
   orig_entry_edge = entry_edge;
 
   split_prologue_seq = NULL_RTX;
-  if (flag_split_stack
+  if (GCC_OPTION (flag_split_stack)
       && (lookup_attribute ("no_split_stack", DECL_ATTRIBUTES (cfun->decl))
 	  == NULL))
     {
@@ -5976,7 +5976,7 @@ thread_prologue_and_epilogue_insns (void)
 	break;
       }
       
-  if (flag_shrink_wrap && HAVE_simple_return
+  if (GCC_OPTION (flag_shrink_wrap) && HAVE_simple_return
       && (targetm.profile_before_prologue () || !crtl->profile)
       && nonempty_prologue && !crtl->calls_eh_return)
     {
@@ -6345,7 +6345,7 @@ thread_prologue_and_epilogue_insns (void)
 #ifdef HAVE_simple_return
   if (entry_edge != orig_entry_edge)
     {
-      if (optimize)
+      if (GCC_OPTION (optimize))
 	{
 	  unsigned i, last;
 
@@ -6382,7 +6382,7 @@ thread_prologue_and_epilogue_insns (void)
       if (exit_fallthru_edge == NULL)
 	goto epilogue_done;
 
-      if (optimize)
+      if (GCC_OPTION (optimize))
 	{
 	  basic_block last_bb = exit_fallthru_edge->src;
 
@@ -6828,7 +6828,7 @@ rest_of_handle_check_leaf_regs (void)
 {
 #ifdef LEAF_REGISTERS
   crtl->uses_only_leaf_regs
-    = optimize > 0 && only_leaf_regs_used () && leaf_function_p ();
+    = GCC_OPTION (optimize) > 0 && only_leaf_regs_used () && leaf_function_p ();
 #endif
   return 0;
 }
@@ -6865,7 +6865,7 @@ used_types_insert (tree t)
   if (TYPE_NAME (t) == NULL_TREE
       || TYPE_NAME (t) == TYPE_NAME (TYPE_MAIN_VARIANT (t)))
     t = TYPE_MAIN_VARIANT (t);
-  if (debug_info_level > DINFO_LEVEL_NONE)
+  if (GCC_OPTION (debug_info_level) > DINFO_LEVEL_NONE)
     {
       if (cfun)
 	used_types_insert_helper (t, cfun);
@@ -6982,7 +6982,7 @@ make_pass_leaf_regs (gcc::context *ctxt)
 static unsigned int
 rest_of_handle_thread_prologue_and_epilogue (void)
 {
-  if (optimize)
+  if (GCC_OPTION (optimize))
     cleanup_cfg (CLEANUP_EXPENSIVE);
 
   /* On some machines, the prologue and epilogue code, or parts thereof,
@@ -6996,7 +6996,7 @@ rest_of_handle_thread_prologue_and_epilogue (void)
   cleanup_cfg (0);
 
   /* The stack usage info is finalized during prologue expansion.  */
-  if (flag_stack_usage_info)
+  if (GCC_OPTION (flag_stack_usage_info))
     output_stack_usage ();
 
   return 0;
diff --git a/gcc/fwprop.c b/gcc/fwprop.c
index 4317f51..ae55d79 100644
--- a/gcc/fwprop.c
+++ b/gcc/fwprop.c
@@ -1449,7 +1449,7 @@ fwprop_done (void)
 static bool
 gate_fwprop (void)
 {
-  return optimize > 0 && flag_forward_propagate;
+  return GCC_OPTION (optimize) > 0 && GCC_OPTION (flag_forward_propagate);
 }
 
 static unsigned int
